local CFG = require "supertable.core"
local DC = require "supertable.declare"

--配置文件路径
local _M = {
	config_file = "/data/configs/kilolink_client.conf"
}

--对讲设备的结构体信息
local talk_set_decl = DC.OBJ {
    ip = DC.STR(),
    port = DC.INT(),
    ifname = DC.ARR(DC.STR("")),
    key = DC.STR(),
    crypto = DC.BOOL(false),
    enable = DC.BOOL(false)
}: __changed( function(conf)
        conf:TAB_SAVE()
end )

--默认初始化对讲设备的对象内容信息
local failDefault={
    ip = "",
    port = 46666,
    ifname = {"eth0"},
    key = "admin",
    enable = false
}

--加载对接设备的设备列表信息
function _M.Load(file)
    local gen_set = CFG.Create( {}, talk_set_decl )
    gen_set:TAB_STORAGE( "file", { file = _M.config_file } )
    local _, r = gen_set:TAB_LOAD()
    if not r then
        gen_set:TAB_BIND( failDefault )
    end
    gen_set:TAB_RESET_CHANGE()
    return gen_set
end

return _M
