local builtin_modelines = require "builtin_modelines"
local MAIN_FREQ = 28636360

print( "Input the error code:" )
local ecode = io.read()

if not ecode or ecode == "" then
	print( "Bad error code input!" )
	os.exit(1)
end

if ecode:sub(1,2) == "E:" or ecode:sub(1,2) == "e:" then
	ecode = ecode:sub(3)
end

local LCF, LCVS, FCL, BL, I_P
 LCF, LCVS, FCL, BL, I_P = ecode:match( "(%d+)/(%d+)/(%d+)/(%d+)/(%w)" )
if not LCF then
	BL, LCVS, LCF, FCL = ecode:match( "(%d+)/(%d+)/(%d+)/(%d+)" )
	if not BL then
		print( "Bad error code input!" )
		os.exit(1)
	end
end

print( "Do you know the original size? If unknown, leave empty ( format is: <width>x<height> ):" )
local knowFormat = io.read()
local refW, refH = knowFormat:match( "(%d+)x(%d+)" )
if not refW or not refH then
	refW = 0
	refH = 0
else
	refW = tonumber(refW)
	refH = tonumber(refH)
end

print( "LCF  :", LCF, "Line Count per Field" )
print( "LCVS :", LCVS, "Line Count per Veritical Sync." )
print( "FCL  : ", FCL, "(MAIN_FREQ clocks per field)/256" )
print( "BL   :", BL, "8 lines MAIN_FREQ clocks" )

local totalLines = LCF
local freq = MAIN_FREQ/FCL/256

print( "RFEQ :", freq, "Refresh frequence" )
print( "" )

local someMatchs = {}
local k, v
for k, v in pairs(builtin_modelines) do
	local diffLCF = math.abs(v.LCF - LCF)
	local diffLCVS = math.abs(v.LCVS - LCVS)
	if diffLCF <= 10 and diffLCVS <=5 then
		if refW > 0 and refH > 0 then
			if v.hAct == refW and v.vAct == refH then
				table.insert( someMatchs, {
					diffLCF = diffLCF,
					diffLCVS = diffLCVS,
					diffFreq = math.abs(freq - v.frameRate),
					modeline = k,
					modeOptions = v
				} )
			end
		else
			table.insert( someMatchs, {
				diffLCF = diffLCF,
				diffLCVS = diffLCVS,
				diffFreq = math.abs(freq - v.frameRate),
				modeline = k,
				modeOptions = v
			} )
		end
	end
end

table.sort( someMatchs, function(a,b)
	if a.diffLCF < b.diffLCF then
		return true
	elseif a.diffLCF == b.diffLCF then
		if a.diffLCVS < b.diffLCVS then
			return true
		elseif a.diffLCVS == b.diffLCVS then
			if a.diffFreq < b.diffFreq then
				return true
			else
				return false
			end
		else
			return false
		end
	else
		return false
	end
end )

local ref_TotalW = 0
local ref_TotalH = 0
local ref_HSyncStart = 0
local ref_HSyncStop = 0
local ref_VSyncStart = 0
local ref_VSyncStop = 0

if #someMatchs > 0 then
	local selRefIdx = 1

	print( "GOOD, I found this format is like your requirement:" )
	print( "***Format:", someMatchs[1].modeOptions.formatName )
	print( someMatchs[1].modeline )
	
	print( "" )
	print( "Also, some others are avaliable for you:" )
	for k, v in pairs(someMatchs) do
		print( "[" .. k .. "] " .. v.modeOptions.formatName, v.modeline )
	end
	
	while true do
		print( "Press ENTER to select default, or input the choose number:" )
		local sel = io.read()
		if not sel or sel == "" then
			break
		else
			sel = tonumber(sel)
			if sel < 1 or sel > #someMatchs then
				print( "WRONG selection. try again." )
			else
				selRefIdx = sel
				break
			end
		end
	end
	refW = someMatchs[selRefIdx].modeOptions.hAct
	refH = someMatchs[selRefIdx].modeOptions.vAct
	ref_TotalW = someMatchs[selRefIdx].modeOptions.hTotal
	ref_TotalH = LCF --someMatchs[selRefIdx].modeOptions.vTotal
	ref_HSyncStart = someMatchs[selRefIdx].modeOptions.hSyncStart
	ref_HSyncStop = someMatchs[selRefIdx].modeOptions.hSyncEnd
	ref_VSyncStart = someMatchs[selRefIdx].modeOptions.vSyncStart
	ref_VSyncStop = someMatchs[selRefIdx].modeOptions.vSyncEnd
else
	print( "SORRY, No builtin reference format for you." )
	if refW <= 0 or refH <=0 then
		while true do
			print( "Now, you must tell me the format size ( <width>x<height> ):" )
			local knowFormat = io.read()
			refW, refH = knowFormat:match( "(%d+)x(%d+)" )
			if refW and refH then
				refW = tonumber(refW)
				refH = tonumber(refH)
				if refW and refW > 0 and refH and refH > 0 then
					break
				end
			end
		end
	end
	
	ref_TotalW = math.floor(refW * 1.3)
	ref_TotalH = LCF
	ref_HSyncStart = math.floor(refW * 1.1)
	ref_HSyncStop = math.floor(refW * 1.2)
	ref_VSyncStart = refH + 1
	ref_VSyncStop = refH + 1 + LCVS
	
end

local pixelFreq = ref_TotalW * ref_TotalH * freq

print( "============== The guess results =============" )
print( ">>> Default result:" )

local genModeline = [["]] .. refW .. "x" .. refH .. "@" .. math.floor(freq) .. [[Hz" ]]
genModeline = genModeline .. (pixelFreq/1000000) .. " " .. refW .. " " .. ref_HSyncStart  .. " " .. ref_HSyncStop .. " " .. ref_TotalW .. " " .. refH .. " " .. ref_VSyncStart .. " " .. ref_VSyncStop .. " " .. ref_TotalH .. " -hsync +vsync"

print( genModeline )

local rest_freq = math.floor(((pixelFreq + 249000)/250000)) * 250000
local vBL = math.floor( MAIN_FREQ / ((rest_freq/ref_TotalW)/8) )
local vFCL = math.floor( MAIN_FREQ / (rest_freq / (ref_TotalW * ref_TotalH)) / 256 )
print( "" )
print( ">>> Restrict frequence result: (BL=" .. vBL .. ", LCVS=" .. LCVS .. ", LCF=" .. LCF .. ", FCL=" .. vFCL .. ")" )

genModeline = [["]] .. refW .. "x" .. refH .. "@" .. math.floor(freq) .. [[Hz" ]]
genModeline = genModeline .. (rest_freq/1000000) .. " " .. refW .. " " .. ref_HSyncStart  .. " " .. ref_HSyncStop .. " " .. ref_TotalW .. " " .. refH .. " " .. ref_VSyncStart .. " " .. ref_VSyncStop .. " " .. ref_TotalH .. " -hsync +vsync"

print( genModeline )
