local control_module = require "controlModule"

local IOLED_SVC = {
	Identifier = "IOLED",
	FriendlyName = "Encoder IO and LEDs controlling service",
	Version = "1.0",
}

function IOLED_SVC:Activate()
end

function IOLED_SVC:Start()
end

function IOLED_SVC:Stop()
end

function IOLED_SVC:Reset()
	control_module.Reset( "reset" )	--Show leds as 'reset' status
end

function IOLED_SVC:Terminate()
	control_module.Reset( "reboot" )	--Show leds as "reboot' status
	os.exit(0)
end

function IOLED_SVC:Control(action,params)
	if action == "activate" then
		self:Activate()
		return 0, {}
	elseif action == "start" then
		self:Start()
		return 0, {}
	elseif action == "stop" then
		self:Stop()
		return 0, {}
	elseif action == "Reset" then
		self:Reset()
		return 0, {}
	elseif action == "terminate" then
		self:Terminate()
		return 0, {}
	elseif action == "enable_uctrl" then
		control_module.SetUserControl(true)
		return 0, {}
	elseif action == "disable_uctrl" then
		control_module.SetUserControl(false)
		return 0, {}
	elseif action == "led_uctrl" then
		control_module.LedControl( params["id"] or "", params["status"] )
		return 0, {}
	else
		return -1, {}
	end
end

----------------------------------------------

local _M = {}

function _M.Init( cosvc )
	if cosvc then
		cosvc:ExposeObject( "/", IOLED_SVC )
	end
	print( "IOLED service online." )
end

return _M
