local DC = require "supertable.declare"
local CONF = require "supertable.core"

local _M = {
	config_file = "/data/configs/portfwd.conf"
}

----------------------------
local portfwd_template = DC.SET(
	DC.OBJ({
		forward_type = DC.STR("user"),
		protocol = DC.STR("tcp"),
		listen = DC.STR(""),
		target = DC.STR(""),
		over = DC.STR(""),
		pkt_size = DC.INT(64),
		tx_buf = DC.INT(256),
		rx_buf = DC.INT(256)
	})
) : __changed( function(conf,name,action)
	conf:TAB_SAVE()
end)

-------------------------------------------

local failDefault = {
}

function _M.Load()
	local conf = CONF.Create({}, portfwd_template)
	conf:TAB_STORAGE( "file", { file =  _M.config_file } )
	local _, r = conf:TAB_LOAD()
	if not r then --Try load a fail-default configure
		conf:TAB_BIND(failDefault)
	end
	conf:TAB_RESET_CHANGE()
	return conf
end

-----------------------------------------------------------

return _M


