local AllPTZConfigs = {
	[1] = {
		Name = "PTZConfig_000",
		UseCount = 1,
		token = "000",
		NodeToken = "000",
		DefaultAbsolutePantTiltPositionSpace = "http://www.onvif.org/ver10/tptz/PanTiltSpaces/PositionGenericSpace",
		DefaultAbsoluteZoomPositionSpace = "http://www.onvif.org/ver10/tptz/ZoomSpaces/PositionGenericSpace",
		DefaultRelativePanTiltTranslationSpace = "http://www.onvif.org/ver10/tptz/PanTiltSpaces/TranslationGenericSpace",
		DefaultRelativeZoomTranslationSpace = "http://www.onvif.org/ver10/tptz/ZoomSpaces/TranslationGenericSpace",
		DefaultContinuousPanTiltVelocitySpace = "http://www.onvif.org/ver10/tptz/PanTiltSpaces/VelocityGenericSpace",
		DefaultContinuousZoomVelocitySpace = "http://www.onvif.org/ver10/tptz/ZoomSpaces/VelocityGenericSpace",
		DefaultPTZSpeed = {
			PanTilt = { x=0.5, y=0.5, space="http://www.onvif.org/ver10/tptz/PanTiltSpaces/GenericSpeedSpace" },
			Zoom = { x=0.5, space="http://www.onvif.org/ver10/tptz/ZoomSpaces/ZoomGenericSpeedSpace" },
		},
		DefaultPTZTimeout = 10,
		PanTiltLimits = {
			Range = {
				URI = "http://www.onvif.org/ver10/tptz/PanTiltSpaces/PositionGenericSpace",
				XRange = { Min=0, Max=1 },
				YRange = { Min=0, Max=1 }
			}
		},
		ZoomLimits = {
			Range = {
				URI = "http://www.onvif.org/ver10/tptz/ZoomSpaces/PositionGenericSpace",
				XRange = { Min=0, Max=1 }
			}
		}
	}
}

local AllPTZNodes = {
	[1] = {
		token = "000",
		Name = "PTZNode0",
		SupportedPTZSpaces = {
			AbsolutePanTiltPositionSpace = {
			{
				URI = "http://www.onvif.org/ver10/tptz/PanTiltSpaces/PositionGenericSpace",
				XRange = 
				{
					Min = -1,
					Max = 1
				},
				YRange = 
				{
					Min = -1, 
					Max = 1
				}
			}},

			AbsoluteZoomPositionSpace = {
			{
				URI = "http://www.onvif.org/ver10/tptz/ZoomSpaces/PositionGenericSpace",
				XRange = 
				{
					Min = 0,
					Max = 1
				}
			}},

			RelativePanTiltTranslationSpace = {
			{
				URI = "http://www.onvif.org/ver10/tptz/PanTiltSpaces/TranslationGenericSpace",
				XRange = 
				{
					Min = -1,
					Max = 1
				},

				YRange = 
				{
					Min = -1, 
					Max = 1
				}
			}},

			RelativeZoomTranslationSpace = {
			{
				URI = "http://www.onvif.org/ver10/tptz/ZoomSpaces/TranslationGenericSpace",
				XRange = 
				{
					Min = -1,
					Max = 1
				}
			}},

			ContinuousPanTiltVelocitySpace = {
			{
				URI = "http://www.onvif.org/ver10/tptz/PanTiltSpaces/VelocityGenericSpace",
				XRange = 
				{
					Min = -1,
					Max = 1
				},

				YRange = 
				{
					Min = -1,
					Max = 1
				}
			}},

			ContinuousZoomVelocitySpace = {
			{
				URI = "http://www.onvif.org/ver10/tptz/ZoomSpaces/VelocityGenericSpace",
				XRange = 
				{
					Min = -1,
					Max = 1
				}
			}},

			PanTiltSpeedSpace = {
			{
				URI = "http://www.onvif.org/ver10/tptz/PanTiltSpaces/GenericSpeedSpace",
				XRange = 
				{
					Min = 0,
					Max = 1
				}
			}},

			ZoomSpeedSpace = {
			{
				URI = "http://www.onvif.org/ver10/tptz/ZoomSpaces/ZoomGenericSpeedSpace",
				XRange = 
				{
					Min = 0,
					Max = 1
				}
			}},
		},

		MaximumNumberOfPresets = 100,
		HomeSupported = 1,
		FixedHomePosition = 1
	}
}

local _M = {}

function _M.GetAllConfigs()
	return AllPTZConfigs
end

function _M.GetAllNodes()
	return AllPTZNodes
end

function _M.GetConfig( token )
	local i
	for i=1, #AllPTZConfigs do
		if AllPTZConfigs[i].token == token then
			return AllPTZConfigs[i]
		end
	end
	return nil
end

function _M.GetNode( token )
	local i
	for i=1, #AllPTZNodes do
		if AllPTZNodes[i].token == token then
			return AllPTZNodes[i]
		end
	end
	return nil
end
return _M


