local timedatectl = require "kiloview.systemd-timedate"
local response = {
	NTPInformation = {
		FromDHCP = 0
	}
}

local items = timedatectl.GetNTPAddress()
if not items or items == "" then
	return response
else
	response.NTPInformation.NTPManual = {}
	
	items = items .. " "
	local x
	for x in items:gmatch("(.-)%s+") do
		if x:match( "^[0-9%.]+$" ) then	--It's IP address
			table.insert( response.NTPInformation.NTPManual, {
				Type = tt__NetworkHostType__IPv4,
				IPv4Address = x
			})
		else
			table.insert( response.NTPInformation.NTPManual, {
				Type = tt__NetworkHostType__DNS,
				DNSname = x
			})
		end
	end
	
	return response
end


--[==[ *ABSTRACT* The 'response' arguments:
{
	NTPInformation: (!)
	{
		FromDHCP: (!)
		(
			xsd__boolean__false_: 0,
			xsd__boolean__true_: 1,
		)
		__sizeNTPFromDHCP: <int>
		NTPFromDHCP[...]: 
		{
			Type: (!)
			(
				tt__NetworkHostType__IPv4: 0,
				tt__NetworkHostType__IPv6: 1,
				tt__NetworkHostType__DNS: 2,
			)
			IPv4Address: <char*>
			IPv6Address: <char*>
			DNSname: <char*>
			Extension: 
			{
				__size: <int>
				__any: <_XML>
			}
			__anyAttribute: <_XML>
		}
		__sizeNTPManual: <int>
		NTPManual[...]: 
		{
			Type: (!)
			(
				tt__NetworkHostType__IPv4: 0,
				tt__NetworkHostType__IPv6: 1,
				tt__NetworkHostType__DNS: 2,
			)
			IPv4Address: <char*>
			IPv6Address: <char*>
			DNSname: <char*>
			Extension: 
			{
				__size: <int>
				__any: <_XML>
			}
			__anyAttribute: <_XML>
		}
		Extension: 
		{
			__size: <int>
			__any: <_XML>
		}
		__anyAttribute: <_XML>
	}
}
]==]


