local file = io.popen( "/sbin/ip route", "r" )
local routes = {}
if file then
	local line = file:read("l")
	while line do
		local addr = line:match( "default%s+via%s+([0-9%.]+)" )
		if addr then
			local metric = line:match( "metric%s+([0-9]+)" )
			if not metric then
				metric = "0"
			end
			metric = tonumber(metric)
			table.insert( routes, { metric=metric, address=addr } )
		end
		line = file:read( "l" )
	end
	file:close()
end

table.sort( routes, function(a,b)
	if a.metric < b.metric then
		return true
	else
		return false
	end
end )

return {
	NetworkGateway = {
		IPv4Address = { routes[1] and routes[1].address or "" }
	}
}

--[==[ *ABSTRACT* The 'response' arguments:
{
	NetworkGateway: (!)
	{
		__sizeIPv4Address: <int>
		IPv4Address: <char**>
		__sizeIPv6Address: <int>
		IPv6Address: <char**>
	}
}
]==]

