local busOprs = require "busOprs"
local args = {...}
local request = args[1]
if not request then
	error( "Invalid request argument passed!" )
end

if request.FromDHCP == 0 and request.DNSManual then	--Manual DNS set
	local dns={}
	local i
	for i=1,#request.DNSManual do
		if request.DNSManual[i].Type == tt__IPType__IPv4 then
			--print( request.DNSManual[i].IPv4Address )
			table.insert(dns, request.DNSManual[i].IPv4Address )
		end
	end
	
	local devices = busOprs.GetIfDevices("*")	--Get all devices.
	if devices then
		local k,v
		for k,v in pairs(devices) do
			if v.TypeName == "ETHERNET" and v.State > 10 then
				local ifconfig = busOprs.CheckIfConfig( v.Object, "WIRE" )
				if not ifconfig.dhcp then
					local args = {
						obj = v.Object,
						uuid = ifconfig.uuid,
						dynamic = 'n',
						ip = ifconfig.ip4addr,
						mask = ifconfig.ip4mask,
						gw = ifconfig.ip4gateway,
						dns1 = dns[1],
						dns2 = dns[2],
						specConn = ifconfig.specConn
					}
					
					busOprs.SetWireIfConfig(args)
					busOprs.UpdateIfConfig(v.Object)
					return SVC_OK
				end
			end
		end
	end
	
	return SVC_OK	--TODO: ???
else
	return SVC_OK
end


--[==[ *ABSTRACT* The 'request' arguments:
{
	FromDHCP: (!)
	(
		xsd__boolean__false_: 0,
		xsd__boolean__true_: 1,
	)
	__sizeSearchDomain: <int>
	SearchDomain: <char**>
	__sizeDNSManual: <int>
	DNSManual[...]: 
	{
		Type: (!)
		(
			tt__IPType__IPv4: 0,
			tt__IPType__IPv6: 1,
		)
		IPv4Address: <char*>
		IPv6Address: <char*>
	}
}
]==]


