local args = {...}
local request = args[1]
if not request then
	error( "Invalid request argument passed!" )
end

local timedatectl = require "kiloview.systemd-timedate"

if request.FromDHCP ~= 1 and request.NTPManual then
	local addresses = ""
	local i
	for i=1, #request.NTPManual do
		if request.NTPManual[i].Type == tt__NetworkHostType__IPv4 then
			if addresses ~= "" then addresses = addresses .. " " end
			addresses = addresses .. request.NTPManual[i].IPv4Address
		elseif request.NTPManual[i].Type == tt__NetworkHostType__DNS then
			if addresses ~= "" then addresses = addresses .. " " end
			addresses = addresses .. request.NTPManual[i].DNSname
		end
	end
	
	local timeinfo = timedatectl.GetTimeDateInfo()
	timedatectl.SetNTPAddresses( addresses )
	if timeinfo["ntp_enabled"] == "yes" then
		os.execute( "/usr/bin/timedatectl set-ntp FALSE" )	--First, try disable it, then update addresses.
		os.execute( "/usr/bin/timedatectl set-ntp TRUE" )
	end
end

return SVC_OK

--[==[ *ABSTRACT* The 'request' arguments:
{
	FromDHCP: (!)
	(
		xsd__boolean__false_: 0,
		xsd__boolean__true_: 1,
	)
	__sizeNTPManual: <int>
	NTPManual[...]: 
	{
		Type: (!)
		(
			tt__NetworkHostType__IPv4: 0,
			tt__NetworkHostType__IPv6: 1,
			tt__NetworkHostType__DNS: 2,
		)
		IPv4Address: <char*>
		IPv6Address: <char*>
		DNSname: <char*>
		Extension: 
		{
			__size: <int>
			__any: <_XML>
		}
		__anyAttribute: <_XML>
	}
}
]==]

--[==[ *ABSTRACT* The 'response' arguments:
{
}
]==]


