local busOprs = require "busOprs"
local args = {...}
local request = args[1]
if not request then
	error( "Invalid request argument passed!" )
end

local MAX_USERS=10

local function SetUser( username, password, level )
	if not username or not level then
		return
	end
	
	if username == "admin" then --This is special
		if password then
			busOprs.Set( { ["onvif.adminPassword"] = password } )
		end
	else
		local i

		for i=0, MAX_USERS-1 do
			if onvif.users[i].username == username then
				local sets = {}
				if password then
					sets[ "onvif.users[" .. i .. "].password" ] = password
				end
				if level then
					if level == tt__UserLevel__Administrator then
						sets[ "onvif.users[" .. i .. "].role" ] = "admin"
					elseif level == tt__UserLevel__Operator then
						sets[ "onvif.users[" .. i .. "].role" ] = "operator"
					elseif level == tt__UserLevel__User then
						sets[ "onvif.users[" .. i .. "].role" ] = "user"
					elseif level == tt__UserLevel__Anonymous then
						sets[ "onvif.users[" .. i .. "].role" ] = "anonymous"
					elseif level == tt__UserLevel__Extended then
						sets[ "onvif.users[" .. i .. "].role" ] = "extended"
					end
				end
				busOprs.Set(sets)
				return
			end
		end
	end
end

local i
for i=1, #request.User do
	SetUser( request.User[i].Username, request.User[i].Password, request.User[i].UserLevel )
end

return SVC_OK

--[==[ *ABSTRACT* The 'request' arguments:
{
	__sizeUser: <int> (!)
	User[...]: (!)
	{
		Username: <char*> (!)
		Password: <char*>
		UserLevel: (!)
		(
			tt__UserLevel__Administrator: 0,
			tt__UserLevel__Operator: 1,
			tt__UserLevel__User: 2,
			tt__UserLevel__Anonymous: 3,
			tt__UserLevel__Extended: 4,
		)
		Extension: 
		{
			__size: <int>
			__any: <_XML>
		}
		__anyAttribute: <_XML>
	}
}
]==]



