local ptzcfgs = require "ptzConfigs"
local args = {...}
local request = args[1]
if not request then
	error( "Invalid request argument passed!" )
end

local conf = ptzcfgs.GetConfig( request.ConfigurationToken )
if not conf then
	return SVC_OK
end

local node = ptzcfgs.GetNode( conf.NodeToken )
if not node then
	return SVC_OK
end


return {
	PTZConfigurationOptions = {
		Spaces = node.SupportedPTZSpaces,
		PTZTimeout = {
			Min = 1000,
			Max = 3000
		}
	}
}

--[==[
		PTControlDirection: 
		{
			EFlip: 
			{
				__sizeMode: <int>
				Mode[...]: 
				(
					tt__EFlipMode__OFF: 0,
					tt__EFlipMode__ON: 1,
					tt__EFlipMode__Extended: 2,
				)
				Extension: 
				{
					__size: <int>
					__any: <_XML>
				}
				__anyAttribute: <_XML>
			}
			Reverse: 
			{
				__sizeMode: <int>
				Mode[...]: 
				(
					tt__ReverseMode__OFF: 0,
					tt__ReverseMode__ON: 1,
					tt__ReverseMode__AUTO: 2,
					tt__ReverseMode__Extended: 3,
				)
				Extension: 
				{
					__size: <int>
					__any: <_XML>
				}
				__anyAttribute: <_XML>
			}
			Extension: 
			{
				__size: <int>
				__any: <_XML>
			}
			__anyAttribute: <_XML>
		}
	}
]==]

--NOTE: SVC_OK = 0, SVC_NOIMPL = 1

