local args = {...}
local request = args[1]
if not request then
	error( "Invalid request argument passed!" )
end

local ptz_m = require "ptzModule"

local i, freePos
local xstr = request.PresetToken or request.PresetName
if xstr then
	xstr = xstr:match("[0-9]+")
end

if xstr then
	freePos = tonumber(xstr)
else	
	for i=1,99 do --Keep 0 for home position
		if not freePos and _G.ptz.presets[i].token == "" then
			freePos = i
		elseif _G.ptz.presets[i].token == request.PresetToken and request.PresetToken ~= "" then
			freePos = i
			break
		end
	end
end

if freePos then
	local tok = request.PresetToken or string.format( "%03d",freePos )
	CONFIGS.BeginUpdate()
	_G.ptz.presets[freePos].token = tok
	_G.ptz.presets[freePos].name = request.PresetName or tok
	CONFIGS.Submit()

	if ptz_m and ptz_m.ptz_obj then
		ptz_m.ptz_obj:SavePreset(freePos)
	end
end

return SVC_OK

--[==[ *ABSTRACT* The 'request' arguments:
{
	ProfileToken: <char*> (!)
	PresetName: <char*>
	PresetToken: <char*>
}
]==]

--[==[ *ABSTRACT* The 'response' arguments:
{
	PresetToken: <char*> (!)
}
]==]

--NOTE: SVC_OK = 0, SVC_NOIMPL = 1

