local args = {...}
local request = args[1]
if not request then
	error( "Invalid request argument passed!" )
end

local ptz = require "ptzModule"
if not ptz or not ptz.ptz_obj then
	return SVC_OK
end

local did = false
if request.PanTilt and request.PanTilt ~= 0 then
	ptz.ptz_obj:StopMove()
	did = true
end

if request.Zoom and request.Zoom ~= 0 then
	ptz.ptz_obj:StopZoom()
	did = true
end

if not did then
	ptz.ptz_obj:StopAll()
end

return SVC_OK

--[==[ *ABSTRACT* The 'request' arguments:
{
	ProfileToken: <char*> (!)
	PanTilt: 
	(
		xsd__boolean__false_: 0,
		xsd__boolean__true_: 1,
	)
	Zoom: 
	(
		xsd__boolean__false_: 0,
		xsd__boolean__true_: 1,
	)
}
]==]


--NOTE: SVC_OK = 0, SVC_NOIMPL = 1

