local args = {...}
local request = args[1]

if not request then
	error( "Invalid request argument passed!" )
end

print( "***TODO: __trt__GetVideoSourceConfigurations" )

local isSub = true
if not request.ProfileToken or request.ProfileToken:match("Profile_Main") then
	isSub = false
end

local maxW = isSub and 960 or 1920
local maxH = isSub and 540 or 1080

return {
	Options = {
		BoundsRange = {
			XRange = { Min=0, Max=maxW },
			YRange = { Min=0, Max=maxH },
			WidthRange = { Min=320, Max=maxW },
			HeightRange = { Min=240, Max=maxH }
		},
		
		VideoSourceTokensAvailable = { "000" }
	}
}

--[==[ *ABSTRACT* The 'request' arguments:
{
	ConfigurationToken: <char*>
	ProfileToken: <char*>
}
]==]

--[==[ *ABSTRACT* The 'response' arguments:
{
	Options: (!)
	{
		BoundsRange: (!)
		{
			XRange: (!)
			{
				Min: <int> (!)
				Max: <int> (!)
			}
			YRange: (!)
			{
				Min: <int> (!)
				Max: <int> (!)
			}
			WidthRange: (!)
			{
				Min: <int> (!)
				Max: <int> (!)
			}
			HeightRange: (!)
			{
				Min: <int> (!)
				Max: <int> (!)
			}
		}
		__sizeVideoSourceTokensAvailable: <int> (!)
		VideoSourceTokensAvailable: <char**> (!)
		Extension: 
		{
			__size: <int>
			__any: <_XML>
			Rotate: 
			{
				__sizeMode: <int> (!)
				Mode[...]: (!)
				(
					tt__RotateMode__OFF: 0,
					tt__RotateMode__ON: 1,
					tt__RotateMode__AUTO: 2,
				)
				DegreeList: 
				{
					__sizeItems: <int>
					Items: <int*>
				}
				Extension: 
				{
					__size: <int>
					__any: <_XML>
				}
				__anyAttribute: <_XML>
			}
			Extension: 
			{
				__size: <int>
				__any: <_XML>
			}
		}
		__anyAttribute: <_XML>
	}
}
]==]

