------------------------------------------------------
-- KILOVIEW Device HTTP Api, v1.0
-- Copyright (c) 2016, KILOVIEW Electronics.
------------------------------------------------------

--[[

##ABSTRACT{G=BASIC}: 通用的参数获取API
>>
>> 编码器产品大多数配置参数，均有一个唯一的Parameter ID，例如：
>>
>> encoder.stream[0].video.codec，对应值为"H264"
>> 
>> 通过指定一个或多个Parameter ID，您可以获得相应的配置参数值；
反之，通过为一个或多个Parameter ID指定值，可以设定编码参数。
>>
>> 所有其它HTTP API，本质上也是修改编码器的对应参数。当然，由于
参数本身数量众多、相互关系较为复杂，所以建议用户依据功能需要
调用对应的API来完成；通用的get/set接口仅作为辅助手段存在。
>>
>> get/set主要的用途是批量获取/设置参数，从而实现 preset 的功能。
>>

##ARGUMENTS{POST}: 
    通过POST参数，指定参数名为Parameter ID（一个或多个），值为
任意。例如：
>>    encoder.stream[0].video.codec: "",
>>    encoder.stream[0].video.bitrate: 0,
>>    ....

>> 另，也可以使用*作为通配符进行匹配，如：
>>    encoder.* 表示获取全部encoder相关的参数
>>    encoder.stream[*].video.* 表示获取所有编码流的视频参数
    	
##RETURNS: 
    ++Data{OBJ}: 返回的参数值列表
        **Parameter-ID-1{STR}: 实际获取的值1
        **Parameter-ID-2{STR}: 实际获取的值2
        **....:  依据请求参数，逐一列出返回值
    ~~

##NOTES:
  有关Parameter ID的列表，请联系原厂技术支持获取。
]]