------------------------------------------------------
-- KILOVIEW Device HTTP Api, v1.0
-- Copyright (c) 2016, KILOVIEW Electronics.
------------------------------------------------------

--[[

##ABSTRACT{G=AV-SOURCE}: 获取模拟音频环出状态
>> 用户可控制模拟音频从In到Out的线路环出。本API可以获得环出状态。

##ARGUMENTS{GET,POST}: 
	无

##RETURNS{DEFAULT}: 
++Data{OBJ}:
	**Enable{INT}: 1表示打开环出功能，0表示关闭环出功能。
~~
]]

local cgilua = require "cgilua"
local rpc = require "kiloview.ringRpc"

local SAPI = SAPI or cgilua.SAPI
SAPI.Response.contenttype( "application/json; charset=utf-8" )

local r,cc,rets = rpc.Call( "BUS.Get", { ["avio.audio.line_bypass"] = 0 } )

cgilua.put([[
{
	"Result":]] .. (r and "200" or "400") .. [[,
	"Status":"]] .. (cc and "OK" or "ERROR: Fail to get audio bypass") .. [[",
	"Data": {
		"Enable":]] .. (rets and rets["avio.audio.line_bypass"] or 0) .. [[
	}
}
]])

