------------------------------------------------------
-- KILOVIEW Device HTTP Api, v1.0
-- Copyright (c) 2016, KILOVIEW Electronics.
------------------------------------------------------

--[[

##ABSTRACT{G=WIFI}: 获得Wi-Fi的全局配置选项
##ARGUMENTS{GET,POST}:

##RETURNS: 
	++Data{OBJ}:
	**ScanPlan{STR}: WiFi的国家/区域/规范选项
		%%0x00: FCC 
		%%0x01: IC 
		%%0x02: ETSI 
		%%0x03: SPAIN 
		%%0x04: FRANCE 
		%%0x05: MKK 
		%%0x06: MKK1 
		%%0x07: ISRAEL 
		%%0x08: TELEC 
		%%0x09: GLOBAL_DOAMIN 
		%%0x0a: WORLD_WIDE_13 
		%%0x0b: TAIWAN 
		%%0x0c: CHINA 
		%%0x0d: SINGAPORE_INDIA_MEXICO (ETSI:Singapore, India. FCC:Mexico => WW)
		%%0x0e: KOREA 
		%%0x0f: TURKEY 
		%%0x10: JAPAN 
		%%0x11: FCC_NO_DFS 
		%%0x12: JAPAN_NO_DFS 
		%%0x13: WORLD_WIDE_5G 
		%%0x14: TAIWAN_NO_DFS 
		%%0x15: ETSI_NO_DFS 
		%%0x16: KOREA_NO_DFS 
		%%0x17: JAPAN_NO_DFS 
		%%0x18: PAKISTAN_NO_DFS 
		%%0x19: TAIWAN2_NO_DFS 
		%%0x1f: WORLD_WIDE_ONLY_5G
	~~
	~~
]]

local cgilua = require "cgilua"
local rpc = require "kiloview.ringRpc"

local SAPI = SAPI or cgilua.SAPI
SAPI.Response.contenttype( "application/json; charset=utf-8" )

local gets = {["hostapm.wifiSpecConfig.country_code"] = "0x0c" }

local r, cc, gets = rpc.Call( "BUS.Get", gets )

if not r or not gets then
	cgilua.put([[
{
	"Result":400,
	"Status":"ERROR: Fail to get arguments"
}
]])
else
	cgilua.put([[
{
	"Result":200,
	"Status":"OK",
	"Data":{
		"ScanPlan":"]] .. string.lower(gets["hostapm.wifiSpecConfig.country_code"] or "") .. [["
	}
}
]])

end

