local cgilua = require "cgilua"
local rpc = require "kiloview.ringRpc"

local SAPI = SAPI or cgilua.SAPI
SAPI.Response.contenttype( "application/json; charset=utf-8" )

local args = require("M_Request").VerifyAndGetArgs()
local key = nil
if args and args.Key and args.Key ~= "" then
	key = args.Key
end

if not key then
	cgilua.put([[
	{
		"Result":400,
		"Status":"Invalid arguments"
	}
]])
else
	local x, r, _a = rpc.Call( "BUS.IRControl", "learn", {["key"] = key} )
	if x and r and r >= 0 then
		cgilua.put([[
		{
			"Result":200,
			"Status":"OK"	
		}
]])
	else
		cgilua.put([[
		{
			"Result":400,
			"Status":"ERROR: ]] .. (_a and _a["msg"] or "unknown") .. [["	
		}
]])
	end
end

