------------------------------------------------------
-- KILOVIEW Device HTTP Api, v1.0
-- Copyright (c) 2016, KILOVIEW Electronics.
------------------------------------------------------

--[[

##ABSTRACT{G=PORTFWD}: Remove a port forwarding item
##ARGUMENTS{GET,POST}: 
  @@Listen{STR,*}: Remove this port fowarding item by speicifed local listening address and port. The format is "address:port", this must match the 'Listen' parameter which added (See ^^REF{addPortForwarding.lua}) 

##RETURNS{DEFAULT}: 

]]

local cgilua = require "cgilua"
local rpc = require "kiloview.ringRpc"

local SAPI = SAPI or cgilua.SAPI
SAPI.Response.contenttype( "application/json; charset=utf-8" )

local args = require("M_Request").VerifyAndGetArgs()
if not args or not args.Listen then
	cgilua.put([[
{
	"Result":400,
	"Status":"invalid-arguments"
}
]])
	return
end

local r,done,msg = rpc.Call( "PORT_FWD.Remove", args.Listen )

if not r or not done then
	cgilua.put([[
	{
		"Result":400,
		"Status":"]] .. (msg or "unknown-error") .. [["
	}
	]])
	return
end

cgilua.put([[
{
	"Result":200,
	"Status":"OK"
}
]])

