------------------------------------------------------
-- KILOVIEW Device HTTP Api, v1.0
-- Copyright (c) 2016, KILOVIEW Electronics.
------------------------------------------------------

--[[


]]

local cgilua = require "cgilua"
local rpc = require "kiloview.ringRpc"
local cjson = require "cjson"


local SAPI = SAPI or cgilua.SAPI
SAPI.Response.contenttype( "application/json; charset=utf-8" )

local args = require("M_Request").VerifyAndGetArgs()
if not args then                                         
        cgilua.put([[                                                                                      
{                                                        
        "Result":400,                                                                                      
        "Status":"ERROR: Invalid request arguments"      
}                                                            
]])
        return
end
                                                                                                    
if not args or type(args) ~= "table" then                                                                                    
		cgilua.put([[ {"Result":400, "Msg":"Invalid arguments"}]])
		return
end                                                                                                                              
																																
-- if not args.addr or not args.addr:match("%d+%.%d+%.%d+%.%d+") then                                                            
--     return [[ {"Result":400, "Msg":"Invalid REMOTE ADDR"}]]                                                                   
-- end                                                                                                                       
if not args.addr then                                                                                                        
	cgilua.put([[ {"Result":400, "Msg":"Invalid REMOTE ADDR"}]])
	return
end                                                                                                                              
																																
if not args.port or not tonumber(args.port) then                                                                                 
	cgilua.put([[ {"Result":400, "Msg":"Invalid REMOTE PORT"}]])
	return
end                                                                                                                          
																																
if not args.poly_enabled or not tonumber(args.poly_enabled) or ( args.poly_enabled ~= "0" and args.poly_enabled ~= "1" ) then
	cgilua.put([[ {"Result":400, "Msg":"Invalid ENABLE ARG"}]])
	return
end

local devs = {}
local tmp = {}

for k,v in pairs(args) do
	if string.sub(k,1,string.len("dev_")) == "dev_" then
		table.insert(tmp, v)
	end
end

table.sort(tmp)
local i=1
for k,v in pairs(tmp) do
		table.insert(devs, { id = i, ifname = v })
		i = i + 1
end

local _x,done,msg = rpc.Call( "POLY.SetNetLink", args.addr, args.port, args.authcode, args.timeout or 15, devs, args.poly_enabled )
if not _x then                                                                                                               
	cgilua.put([[ {"Result":400, "Msg":"]] .. (done or "ERROR") .. [["} ]])
	return
elseif not done then                                                                                                         
	cgilua.put([[ {"Result":400, "Msg":"]] .. (msg or "ERROR") .. [["} ]])
	return
else
	cgilua.put([[ {"Result":200, "Msg":"Updated."}]])
	return
end
