------------------------------------------------------
-- KILOVIEW Device HTTP Api, v1.0
-- Copyright (c) 2016, KILOVIEW Electronics.
------------------------------------------------------

local cgilua = require "cgilua"
local rpc = require "kiloview.ringRpc"

local SAPI = SAPI or cgilua.SAPI
SAPI.Response.contenttype( "application/json; charset=utf-8" )

local stream
local args = require("M_Request").VerifyAndGetArgs()
if not args or not args.Stream or args.Stream == "" then
	cgilua.put([[
	{
		"Result":400,
		"Status":"ERROR: Invalid stream"
	}
]])
	return
end

stream = args.Stream

local streamId = 0
if stream == "sub" then
	streamId = 1
end

local argPrefix = "streamer.stream[" .. streamId .. "].Scrambling"
local sets = {}

if args.Enable and args.Enable ~= "" then
	sets[ argPrefix .. ".enabled" ] = tonumber(args.Enable) or 0
end

--[[
if args.Seed and args.Seed ~= "" then
	local seed = args.Seed
	local depth = nil
	local prefix = seed:sub(1,2)
	if prefix == "0x" or prefix == "0X" then
		seed = seed:sub(3)
		if seed == "" then
			seed = "0"
		end
	end
	local pos = #seed - 7
	if pos > 1 then
		depth = seed:sub(1,pos-1)
		seed = seed:sub(pos)
	end

	sets[ argPrefix .. ".seed" ] = "0x" .. seed
	sets[ argPrefix .. ".depth" ] = "0x" .. ( depth or "00000000" )
end
]]


if args.Seed and args.Seed ~= "" then
	local seed = args.Seed
	local prefix = seed:sub(1,2)
	if prefix ~= "0x" and prefix ~= "0X" then
		seed = "0x" .. seed
	end
	sets[ argPrefix .. ".seed" ] = seed
end

local r,x = rpc.Call( "BUS.Set", sets )
if not r or not x then
	cgilua.put([[
{
	"Result":400,
	"Status":"ERROR: Fail to set scrambling"
}
]])
else
	cgilua.put([[
{
	"Result":200,
	"Status":"OK"
}
]])
end
