------------------------------------------------------
-- KILOVIEW Device HTTP Api, v1.0
-- Copyright (c) 2016, KILOVIEW Electronics.
------------------------------------------------------

--[[

##ABSTRACT{G=ENCODING}: 更新主码流/子码流。

>>{BOLD} 对码流的更新，主要是针对H.264编码的视频，强制要求刷新I帧。

##ARGUMENTS{GET,POST}: 
    @@Stream{*}: 指定码流
        %%main: 主码流
        %%sub: 子码流
    ~~

##RETURNS{DEFAULT}: 
]]

local cgilua = require "cgilua"
local rpc = require "kiloview.ringRpc"

local SAPI = SAPI or cgilua.SAPI
SAPI.Response.contenttype( "application/json; charset=utf-8" )

local args = require("M_Request").VerifyAndGetArgs()
if not args or not args.Stream or args.Stream == "" then
	cgilua.put([[
{
	"Result":400,
	"Status":"ERROR: Invalid arguments"
}
]])
	return
end

local stream = 0
if args.Stream == "sub" then
	stream = 1
end

local r, x = rpc.Call( "BUS.UpdateEncoding", string.format("%02d", stream ) )
if r and x then
	cgilua.put([[
{
	"Result":200,
	"Status":"OK"
}
]])
else
	cgilua.put([[
{
	"Result":400,
	"Status":"Fail to update encoding"
}
]])
end
