--Controller of roleman
local _M = require( "controller.generic" )()
local cgilua = require "cgilua"

------------
local function AddRole( role )
	if not role or role == "" then
		return [[ {"Result":400, "Msg":"]] .. _M.langs.ERRMSG_INVALID_ROLE .. [["}]]
	end

	local r,x,status = _M.MasterCall( "SERVER.AddRole", role )
	if r then 
		if x then
			return [[ {"Result":200, "Msg":"]] .. _M.langs.MSG_ADD_DONE .. [[", "Refresh":1 }]]
		else
			return [[ {"Result":400, "Msg":"]] .. (_M.langs.MSG_OPRFAILS[status] or _M.langs.MSG_UNKNOWN_ERROR).. [[" }]]
		end
	else
		return [[ {"Result":400, "Msg":"]] .. _M.langs.MSG_ADD_FAIL .. [["}]]
	end
end

local function ChangeRole(args)
	if not args or type(args) ~= "table" then
		return [[ {"Result":400, "Msg":"]] .. _M.langs.ERRMSG_INVALID_POST_ARGS .. [["}]]
	end
	
	local rolename = args.rolename
	if not rolename or rolename == "" then
		return [[ {"Result":400, "Msg":"]] .. _M.langs.ERRMSG_INVALID_ROLE .. [["}]]
	end

	args.rolename = nil --Clear this field.

	local r,x,status = _M.MasterCall( "SERVER.ChangeRole", rolename, args, false ) --Not update but whole replace.
	if r then 
		if x then
			return [[ {"Result":200, "Msg":"]] .. _M.langs.MSG_CHANGE_DONE .. [[", "Refresh":1 }]]
		else
			return [[ {"Result":400, "Msg":"]] .. (_M.langs.MSG_OPRFAILS[status] or _M.langs.MSG_UNKNOWN_ERROR).. [[" }]]
		end
	else
		return [[ {"Result":400, "Msg":"]] .. _M.langs.MSG_CHANGE_FAIL .. [["}]]
	end
end

local function RemoveRole(role)
	if not role or role == "" then
		return [[ {"Result":400, "Msg":"]] .. _M.langs.ERRMSG_INVALID_ROLE .. [["}]]
	end
	local r,x,status = _M.MasterCall( "SERVER.DelRole", role )
	if r then 
		if x then
			return [[ {"Result":200, "Msg":"]] .. _M.langs.MSG_REMOVE_DONE .. [[", "Refresh":1 }]]
		else
			return [[ {"Result":400, "Msg":"]] .. (_M.langs.MSG_OPRFAILS[status] or _M.langs.MSG_UNKNOWN_ERROR).. [[" }]]
		end
	else
		return [[ {"Result":400, "Msg":"]] .. _M.langs.MSG_REMOVE_FAIL .. [["}]]
	end
end
-------------- AJAX CALL ----------------
_M.AjaxExport ("AddRole", AddRole, "json") 
_M.AjaxExport ("RemoveRole", RemoveRole, "json" )
_M.AjaxExport ("ChangeRole", ChangeRole, "json" )
---------------------------------------------

function _M.GetRoles()
	local r,gets = _M.MasterCall( "SERVER.GetRolesJsonDetail")
	if r and gets then
		return gets
	else
		return nil
	end
end

return _M

