--Controller of sysconfig
local _M = require( "controller.generic" )()
local cgilua = require "cgilua"

---------- AJAX Call -----------
local function AddSerial( args )
	if not args or type(args) ~= "table" or type(args["serialno"]) ~= "string" then
		return [[ {"Result":400, "Msg":"WRONG! Invalid arguments!"}]]
	end
	_M.MasterCall( "CONFIG_MANAGER.AddSerialNo", args["date"], args["serialno"], args["comment"] or "" )
	_M.MasterCall( "SERVER.UpdateSystemConfigs" )
	return [[ {"Result":200, "Msg":"New serial number has been added."}]]
end

local function AddLangs( args )
	if not args or type(args) ~= "table" or type(args["langs"]) ~= "string" or type(args["def_lang"]) ~= "string" then
		return [[ {"Result":400, "Msg":"WRONG! Invalid arguments!"}]]
	end
	_M.MasterCall( "CONFIG_MANAGER.AddLanguageSupport", args["date"], args["langs"], args["def_lang"], args["comment"] or "" )
	_M.MasterCall( "SERVER.UpdateSystemConfigs" )
	return [[ {"Result":200, "Msg":"New language support has been added."}]]
end	

local function AddSerialLocal( serial, mac, date )
	if not serial or not mac or serial == "" or mac == "" then
		return [[ {"Result":400, "Msg":"WRONG! Invalid arguments!"}]]
	end

	if not mac:match("%w%w:%w%w:%w%w:%w%w:%w%w:%w%w") then
		return [[ {"Result":400, "Msg":"WRONG! Invalid arguments!"}]]
	end

    _M.MasterCall( "CONFIG_MANAGER.AddSerialNoLocal", date, serial, mac )
	_M.MasterCall( "SERVER.UpdateSystemConfigs" )
	return [[ {"Result":200, "Msg":"New serial number has been added."}]]
end

--------------------------------
_M.AjaxExport  ("AddSerial", AddSerial, "json") 
_M.AjaxExport  ("AddLangs", AddLangs, "json") 
_M.AjaxExport  ("AddSerialLocal", AddSerialLocal, "json") 
--------------------------------

return _M
