--Controller of userman
local _M = require( "controller.generic" )()
local cgilua = require "cgilua"

------------
local function AddUser( username, password, defLang, role )
	if not username or username == "" or not password or password == "" then
		return [[ {"Result":400, "Msg":"]] .. _M.langs.ERRMSG_INVALID_USERNAME_OR_PASSWORD .. [["}]]
	end

	local r,x,status = _M.MasterCall( "SERVER.AddUser", username, password, defLang, role )
	if r then 
		if x then
			return [[ {"Result":200, "Msg":"]] .. _M.langs.MSG_ADD_DONE .. [[", "Refresh":1 }]]
		else
			return [[ {"Result":400, "Msg":"]] .. (_M.langs.MSG_OPRFAILS[status] or _M.langs.MSG_UNKNOWN_ERROR).. [[" }]]
		end
	else
		return [[ {"Result":400, "Msg":"]] .. _M.langs.MSG_ADD_FAIL .. [["}]]
	end
end

local function ChangeUser( username, password, defLang, role )
	if not username or username == "" or not password or password == "" then
		return [[ {"Result":400, "Msg":"]] .. _M.langs.ERRMSG_INVALID_USERNAME_OR_PASSWORD .. [["}]]
	end

	local r,x,status = _M.MasterCall( "SERVER.ChangeUser", username, password, defLang, role )
	if r then 
		if x then
			return [[ {"Result":200, "Msg":"]] .. _M.langs.MSG_CHANGE_DONE .. [[", "Refresh":1 }]]
		else
			return [[ {"Result":400, "Msg":"]] .. (_M.langs.MSG_OPRFAILS[status] or _M.langs.MSG_UNKNOWN_ERROR).. [[" }]]
		end
	else
		return [[ {"Result":400, "Msg":"]] .. _M.langs.MSG_CHANGE_FAIL .. [["}]]
	end
end

local function RemoveUser(username)
	if not username or username == "" then
		return [[ {"Result":400, "Msg":"]] .. _M.langs.ERRMSG_INVALID_USERNAME_OR_PASSWORD .. [["}]]
	end
	local r,x,status = _M.MasterCall( "SERVER.DelUser", username )
	if r then 
		if x then
			return [[ {"Result":200, "Msg":"]] .. _M.langs.MSG_REMOVE_DONE .. [[", "Refresh":1 }]]
		else
			return [[ {"Result":400, "Msg":"]] .. (_M.langs.MSG_OPRFAILS[status] or _M.langs.MSG_UNKNOWN_ERROR).. [[" }]]
		end
	else
		return [[ {"Result":400, "Msg":"]] .. _M.langs.MSG_REMOVE_FAIL .. [["}]]
	end
end
-------------- AJAX CALL ----------------
_M.AjaxExport ("AddUser", AddUser, "json") 
_M.AjaxExport ("RemoveUser", RemoveUser, "json" )
_M.AjaxExport ("ChangeUser", ChangeUser, "json" )
---------------------------------------------

function _M.GetUsers()
	local r,gets = _M.MasterCall( "SERVER.GetUsers")
	if r and gets then
		return gets
	else
		return nil
	end
end

return _M

