﻿var	rule = {
			// Regular
			"jpn" :/^[\u0391-\uFFE5]+$/,
			"eng" : /^[A-Za-z]+$/,
			"chn" :/^[\u0391-\uFFE5]+$/,
			"mail" : /\w+([-+.]\w+)*@\w+([-.]\w+)*\.\w+([-.]\w+)*/,
			"url" : /^http[s]?:\/\/[A-Za-z0-9]+\.[A-Za-z0-9]+[\/=\?%\-&_~`@[\]\':+!]*([^<>\"\"])*$/,
			"currency" : /^\d+(\.\d+)?$/,
			"number" : /^\d+$/,
			"int" : /^[0-9]{1,30}$/,
			"tdouble" : /^[-\+]?\d+(\.\d+)?$/,
			"username" : /^[^><'"]{1,50}$/ ,
			"password" : /^[^><'"]{1,50}$/ ,
			"safe" : />|<|,|\[|\]|\{|\}|\?|\/|\+|=|\||\'|\\|\"|:|;|\~|\!|\@|\#|\*|\$|\%|\^|\&|\(|\)|`/i,
			"dbc" : /[ａ-ｚＡ-Ｚ０-９！＠＃￥％＾＆＊（）＿＋｛｝［］｜：＂＇；．，／？＜＞｀～　]/,
			"qq" : /[1-9][0-9]{4,}/,
			"date" : /^((((1[6-9]|[2-9]\d)\d{2})-(0?[13578]|1[02])-(0?[1-9]|[12]\d|3[01]))|(((1[6-9]|[2-9]\d)\d{2})-(0?[13456789]|1[012])-(0?[1-9]|[12]\d|30))|(((1[6-9]|[2-9]\d)\d{2})-0?2-(0?[1-9]|1\d|2[0-8]))|(((1[6-9]|[2-9]\d)(0[48]|[2468][048]|[13579][26])|((16|[2468][048]|[3579][26])00))-0?2-29-))$/,
			"year" : /^(19|20)[0-9]{2}$/,
			"month" : /^(0?[1-9]|1[0-2])$/,
			"day" : /^((0?[1-9])|((1|2)[0-9])|30|31)$/,
			"hour" : /^((0?[1-9])|((1|2)[0-3]))$/,
			"minute" : /^((0?[1-9])|((1|5)[0-9]))$/,
			"second" : /^((0?[1-9])|((1|5)[0-9]))$/,
			"mobile" : /^((\(\d{2,3}\))|(\d{3}\-))?13\d{9}$/,
			"phone" : /^[+]{0,1}(\d){1,3}[ ]?([-]?((\d)|[ ]){1,12})+$/,
			"zipcode" : /^[1-9]\d{5}$/,
			"bodycard" : /^((1[1-5])|(2[1-3])|(3[1-7])|(4[1-6])|(5[0-4])|(6[1-5])|71|(8[12])|91)\d{4}((19\d{2}(0[13-9]|1[012])(0[1-9]|[12]\d|30))|(19\d{2}(0[13578]|1[02])31)|(19\d{2}02(0[1-9]|1\d|2[0-8]))|(19([13579][26]|[2468][048]|0[48])0229))\d{3}(\d|X|x)?$/,
			"ip" : /^(\d{1,2}|1\d\d|2[0-4]\d|25[0-5])\.(\d{1,2}|1\d\d|2[0-4]\d|25[0-5])\.(\d{1,2}|1\d\d|2[0-4]\d|25[0-5])\.(\d{1,2}|1\d\d|2[0-4]\d|25[0-5])$/,		
			"file": /^[A-Za-z0-9]+((\.|-)[A-Za-z0-9]+)*\.[A-Za-z0-9]+$/,
			"image" : /.+\.(jpg|gif|png|bmp)$/i,
			"word" : /.+\.(doc|rtf|pdf)$/i,
			"netmac" : /([a-fA-F0-9]|[:]){17,17}$/,
			//"fftext" :/^([a-zA-Z0-9]|[;!-?:,._ ]|[\u0391-\uFFE5]){0,24}$/,
			"fftext" :/^[^><'"]{1,24}$/ ,
			"datetime" : /^((((1[6-9]|[2-9]\d)\d{2})-(0?[13578]|1[02])-(0?[1-9]|[12]\d|3[01]))|(((1[6-9]|[2-9]\d)\d{2})-(0?[13456789]|1[012])-(0?[1-9]|[12]\d|30))|(((1[6-9]|[2-9]\d)\d{2})-0?2-(0?[1-9]|1\d|2[0-8]))|(((1[6-9]|[2-9]\d)(0[48]|[2468][048]|[13579][26])|((16|[2468][048]|[3579][26])00))-0?2-29-)) (20|21|22|23|[0-1]?\d):[0-5]?\d:[0-5]?\d$/,
			"sessionid" : /^[^><'"]{1,256}$/ ,
			// Function regular
			"eq": function(arg1,arg2){ return arg1==arg2 ? true:false;},
			"gt": function(arg1,arg2){ return arg1>arg2 ? true:false;},
			"gte": function(arg1,arg2){ return arg1>=arg2 ? true:false;},
			"lt": function(arg1,arg2){ return arg1<arg2 ? true:false;},
			"lte": function(arg1,arg2){ return arg1<=arg2 ? true:false;}	
		};

//NOW, msgSuffix is defined in lang_xx.js

$.extend($.fn.validatebox.defaults.rules, 
{
    jpn:     { validator: function( value, param  ){ return  rule.eng.test(  value ) ;      }, message: msgSuffix.jpn	},
    eng:     { validator: function( value, param  ){ return  rule.eng.test(  value ) ;      }, message: msgSuffix.eng   },
    chn:     { validator: function( value, param  ){ return  rule.chn.test(  value ) ;      }, message: msgSuffix.chn   },
    username:{ validator: function( value, param  ){ return  rule.username.test(  value ) ; }, message: msgSuffix.username },
    sessionid:{ validator: function( value, param  ){ return  rule.sessionid.test(  value ) ; }, message: msgSuffix.sessionid },
    password:{ validator: function( value, param  ){ return  rule.password.test(  value ) ; }, message: msgSuffix.password },
    netmac:  { validator: function( value, param  ){ return  rule.netmac.test(  value ) ;   }, message: msgSuffix.netmac },
    fftext:  { validator: function( value, param  ){ return  rule.fftext.test(  value ) ;   }, message: msgSuffix.fftext },
    ip:      { validator: function( value, param  ){ return  rule.ip.test(  value ) ;       }, message: msgSuffix.ip },
    datetime:{ validator: function( value, param  ){ return  rule.datetime.test( value );	  }, message: msgSuffix.datetime },
    eq:			 { validator: function( value, param  ){ 
					    		var k_target = param[ 0 ];
					    		var k_value = $( k_target ).val();
					    		return value==k_value ? true:false;
    				 }, message: msgSuffix.eq },
    tdouble: { validator: function( value, param  ){ 
		    						if(   rule.tdouble.test(  value ) ){
		    								if( (value<=2) && (value>=1) ){
		    							  		return true;
		    							  }	
		    						} 
		    						return false;
	    				}, message: msgSuffix.tdouble }
});