#!/usr/bin/lua 

pcall(require, "sys_setting")

local getmac=nil

local f = io.open( "/etc/DEFAULT_MAC", "r" )
if f then
	local line=f:read("l")
	if line and #line >= 17 then
		getmac=line:match("(%x%x:%x%x:%x%x:%x%x:%x%x:%x%x)")
	end
	f:close()
end

--A previous bug may cause mac address be 0a:80:00:00:00:00
if getmac and getmac == "0a:80:00:00:00:00" then
	getmac = nil
end

if not getmac and type(_G.KV.SERIAL_HISTORIES) == "table" and #_G.KV.SERIAL_HISTORIES > 0 then
	local serial = _G.KV.SERIAL_HISTORIES[ #_G.KV.SERIAL_HISTORIES ].serial
	if type(serial) == "string" then
		if serial:match("^[0-9a-fA-F]*$") then
			serial = "000000000" .. serial
		else
			local pf = io.popen("/bin/echo " .. serial .. " | /usr/bin/md5sum", "r" )
			if pf then
				serial = pf:read("*l")
				pf:close()
				if serial then
					serial = serial:sub(1,32)
				else
					serial = "000000000"
				end
			else
				serial = "000000000"
			end
		end
		local t1,t2,t3,t4,t5 = serial:match( "[0-9a-fA-F]*([0-9a-fA-F])([0-9a-fA-F][0-9a-fA-F])([0-9a-fA-F][0-9a-fA-F])([0-9a-fA-F][0-9a-fA-F])([0-9a-fA-F][0-9a-fA-F])" )
		getmac = "0a:8" .. t1 .. ":" .. t2 .. ":" .. t3 .. ":" .. t4 .. ":" .. t5
		f = io.open( "/etc/DEFAULT_MAC", "w" )
		if f then
			f:write( getmac )
			f:close()
		end
	end
end

if getmac then
	os.execute( "/sbin/ifconfig eth0 hw ether " .. getmac )
end

os.exit(0)
