local _M = {}

function _M.ProcessUpgradeFirmware( filename, tmpLoc )
	tmpLoc = tmpLoc or "/tmp/.fw_upgrade"
	os.execute( [[/bin/mkdir -p "]] .. tmpLoc .. [["]] )
	os.execute( [[/bin/rm "]] .. tmpLoc .. [["/* -Rf]] )
	local did,signal,code = os.execute( [[/bin/tar xzf "]] .. filename .. [[" -C "]] .. tmpLoc .. [[" .]] )
	if not did or signal ~= "exit" or code ~= 0 then
		return false, "extract.fail"
	end
	
	os.execute( [[/bin/rm "]] .. filename .. [[" -f]] )	--Drop original file
	
	local invoker
	did,invoker = pcall( dofile, tmpLoc .. "/pre-check.lua" )
	if did and type(invoker) == "function" then
		local rslt, errTag, errMsg
		did, rslt, errTag, errMsg = pcall( invoker, tmpLoc )
		if not did then
			os.execute( [[/bin/rm "]] .. tmpLoc .. [["/* -Rf]] )
			return false, "precheck.exec-fail"
		end
		
		if not rslt then
			os.execute( [[/bin/rm "]] .. tmpLoc .. [["/* -Rf]] )
			return rslt, errTag, errMsg
		end
	end
	
	--Well, precheck is OK or not required, try 'pre-uprade.sh'
	os.execute( [[/bin/chmod +x "]] .. tmpLoc .. [[/pre-upgrade.sh"]] )
	did,signal,code = os.execute( [["]] .. tmpLoc .. [["/pre-upgrade.sh "]] .. tmpLoc .. [["]] )
	if did and signal == "exit" and code == 0 then
		return true, "done"
	else
		os.execute( [[/bin/rm "]] .. tmpLoc .. [["/* -Rf]] )
		return false, "preupgrade.exec-fail"
	end
	
end

return _M

