-- Upgrade pre-check
CHECK_DEVICE_TYPE = "RE2"
CHECK_OEM_TYPE = nil
CHECK_VERSION_MATCH = true
VERSION_MATCH_ONLY = nil
VERSION_MATCH_LT = "4.8.2561"
VERSION_MATCH_GT = "0"
NEW_VERSION="4.8.2561"
---- Up before this are arguments auto generated by upgrading scripts ---
local function DEVICE_UPGRADE_POSSIBLE(device_type)
	if not CHECK_DEVICE_TYPE then return true end
	if type(device_type) ~= "string" then
		return false
	end
	for tok in CHECK_DEVICE_TYPE:gmatch("([^%s]+)%s*") do
		if tok:lower() == device_type:lower() then
			return true
		end
	end
	return false
end

local function PRODUCT_UPGRADE_POSSIBLE(product_id)
	if not CHECK_OEM_TYPE then return true end
	if type(product_id) ~= "string" then
		return false
	end
	for tok in CHECK_OEM_TYPE:gmatch("([^%s]+)%s*") do
		if tok:lower() == product_id:lower() then
			return true
		end
	end
	return false
end

local function UpgradePreCheck( tmpLoc )
	if CHECK_DEVICE_TYPE or CHECK_OEM_TYPE then
		local done, _r = pcall(require,"oem")
		if not done then
			return false, "device-type-error"
		end
		if not DEVICE_UPGRADE_POSSIBLE(_G.DEVICE_TYPE) then
			return false, "device-type-error"
		end
		if not PRODUCT_UPGRADE_POSSIBLE(_G.OEM_TYPE) then
			return false, "device-type-error"
		end
	end

	if CHECK_VERSION_MATCH then
		local done, _r = pcall(require,"version")
		if not done or not SOFTWARE_VERSION then
			return false, "device-type-error"
		end
		if VERSION_MATCH_ONLY then
			if SOFTWARE_VERSION ~= VERSION_MATCH_ONLY and SOFTWARE_VERSION ~= NEW_VERSION then
				return false, "version-wrong"
			end
		--Only matched numeric '.????' suffix.
		elseif SOFTWARE_VERSION:match("%.%d?%d?%d?%d?$") then
			if SOFTWARE_VERSION < VERSION_MATCH_GT then
				return false, "bin-base-version-is-higher"
			elseif SOFTWARE_VERSION > VERSION_MATCH_LT then
				return false, "bin-version-is-old"
			end
		end
	end

	return true, "done"
end

return UpgradePreCheck

